(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/cdk/coercion')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/components/button', ['exports', '@angular/common', '@angular/core', '@angular/cdk/coercion'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.button = {}), global.ng.common, global.ng.core, global.ng.cdk.coercion));
}(this, (function (exports, common, core, coercion) { 'use strict';

    var NtButtonGroupComponent = /** @class */ (function () {
        function NtButtonGroupComponent() {
            this._expanded = false;
            this.class = '';
            this.color = '';
            this.size = '';
        }
        Object.defineProperty(NtButtonGroupComponent.prototype, "expanded", {
            get: function () { return this._expanded; },
            set: function (value) { this._expanded = coercion.coerceBooleanProperty(value); },
            enumerable: false,
            configurable: true
        });
        return NtButtonGroupComponent;
    }());
    NtButtonGroupComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-button-group, [nt-button-group]',
                    template: "<ng-content></ng-content>",
                    encapsulation: core.ViewEncapsulation.None,
                    host: {
                        '[class]': '["button-group", color, size, class].join(" ")',
                        '[class.expanded]': 'expanded'
                    }
                },] }
    ];
    NtButtonGroupComponent.propDecorators = {
        class: [{ type: core.Input }],
        color: [{ type: core.Input }],
        size: [{ type: core.Input }],
        expanded: [{ type: core.Input }]
    };

    var NtButtonComponent = /** @class */ (function () {
        function NtButtonComponent() {
            this._style = '';
            this._expanded = false;
            this.class = '';
            this.color = '';
            this.size = '';
        }
        Object.defineProperty(NtButtonComponent.prototype, "button", {
            set: function (value) {
                if (this._validStyle(value)) {
                    this._style = value;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtButtonComponent.prototype, "style", {
            get: function () { return this._style; },
            set: function (value) { this._style = value; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtButtonComponent.prototype, "expanded", {
            get: function () { return this._expanded; },
            set: function (value) { this._expanded = coercion.coerceBooleanProperty(value); },
            enumerable: false,
            configurable: true
        });
        NtButtonComponent.prototype._validStyle = function (value) {
            return ['', 'hollow', 'clear'].indexOf(value) > -1;
        };
        return NtButtonComponent;
    }());
    NtButtonComponent.decorators = [
        { type: core.Component, args: [{
                    selector: '[nt-button]',
                    template: "<ng-content></ng-content>",
                    encapsulation: core.ViewEncapsulation.None,
                    host: {
                        '[class]': '["button", color, style, size, class].join(" ")',
                        '[class.expanded]': 'expanded'
                    }
                },] }
    ];
    NtButtonComponent.propDecorators = {
        class: [{ type: core.Input }],
        color: [{ type: core.Input }],
        size: [{ type: core.Input }],
        button: [{ type: core.Input, args: ['nt-button',] }],
        style: [{ type: core.Input }],
        expanded: [{ type: core.Input }]
    };

    var NtButtonModule = /** @class */ (function () {
        function NtButtonModule() {
        }
        return NtButtonModule;
    }());
    NtButtonModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [NtButtonComponent, NtButtonGroupComponent],
                    declarations: [NtButtonComponent, NtButtonGroupComponent],
                },] }
    ];

    exports.NtButtonComponent = NtButtonComponent;
    exports.NtButtonGroupComponent = NtButtonGroupComponent;
    exports.NtButtonModule = NtButtonModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=button.umd.js.map
