(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/observers'), require('@angular/common'), require('@angular/core'), require('@ng-tangram/components/overlay'), require('rxjs'), require('@angular/cdk/coercion'), require('@angular/cdk/overlay')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/components/dropdown', ['exports', '@angular/cdk/observers', '@angular/common', '@angular/core', '@ng-tangram/components/overlay', 'rxjs', '@angular/cdk/coercion', '@angular/cdk/overlay'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.dropdown = {}), global.ng.cdk.observers, global.ng.common, global.ng.core, global.nt.components.overlay, global.rxjs, global.ng.cdk.coercion, global.ng.cdk.overlay));
}(this, (function (exports, observers, common, core, overlay, rxjs, coercion, overlay$1) { 'use strict';

    var NT_DROPDOWN_PARENT_COMPONENT = new core.InjectionToken('nt-dropdown-parent-component');
    var NtDropdownPaneComponent = /** @class */ (function () {
        function NtDropdownPaneComponent(_contentObserver, _elementRef, _parent) {
            this._contentObserver = _contentObserver;
            this._elementRef = _elementRef;
            this._parent = _parent;
            this._arrow = false;
            this._autosize = false;
            this.size = 'small';
            this.class = '';
            this._contentChange = new rxjs.Subject();
        }
        Object.defineProperty(NtDropdownPaneComponent.prototype, "autosize", {
            get: function () { return this._autosize; },
            set: function (value) {
                this._autosize = coercion.coerceBooleanProperty(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDropdownPaneComponent.prototype, "arrow", {
            get: function () { return this._arrow; },
            set: function (value) { this._arrow = coercion.coerceBooleanProperty(value); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDropdownPaneComponent.prototype, "contentChanged", {
            get: function () {
                return this._contentChange.asObservable();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtDropdownPaneComponent.prototype, "textContent", {
            get: function () {
                return (this._elementRef.nativeElement.textContent || '').trim();
            },
            enumerable: false,
            configurable: true
        });
        NtDropdownPaneComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            this._contentSubscription = this._contentObserver
                .observe(this._elementRef)
                .subscribe(function () { return _this._checkContentChange(); });
        };
        NtDropdownPaneComponent.prototype.ngOnDestroy = function () {
            if (this._contentSubscription) {
                this._contentSubscription.unsubscribe();
            }
        };
        NtDropdownPaneComponent.prototype._checkContentChange = function () {
            if (this._parent.overlay.opened) {
                this._parent.overlay.forceUpdatePosition();
            }
        };
        return NtDropdownPaneComponent;
    }());
    NtDropdownPaneComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-dropdown-pane, [nt-dropdown-pane]',
                    template: '<ng-content></ng-content>',
                    encapsulation: core.ViewEncapsulation.None,
                    host: {
                        '[class]': '["nt-dropdown-pane", size, class].join(" ")',
                        '[class.autosize]': 'autosize'
                    }
                },] }
    ];
    NtDropdownPaneComponent.ctorParameters = function () { return [
        { type: observers.ContentObserver },
        { type: core.ElementRef },
        { type: undefined, decorators: [{ type: core.Inject, args: [NT_DROPDOWN_PARENT_COMPONENT,] }] }
    ]; };
    NtDropdownPaneComponent.propDecorators = {
        size: [{ type: core.Input }],
        class: [{ type: core.Input }],
        autosize: [{ type: core.Input }],
        arrow: [{ type: core.Input }]
    };

    var NtDropdownComponent = /** @class */ (function () {
        function NtDropdownComponent(_elementRef) {
            this.position = overlay.NtOverlayPosition.BottomLeft;
            this.trigger = 'hover';
            this.afterOpen = new core.EventEmitter();
            this.afterClosed = new core.EventEmitter();
            this.beforeOpen = new core.EventEmitter();
            this.beforeClosed = new core.EventEmitter();
            this.positionChange = new core.EventEmitter();
            this.origin = new overlay$1.CdkOverlayOrigin(_elementRef);
        }
        NtDropdownComponent.prototype._onClick = function (_) {
            if (this.trigger === 'click') {
                this.overlay.toggle();
            }
        };
        NtDropdownComponent.prototype._onMouseEnter = function (_) {
            if (this.trigger === 'hover') {
                this.overlay.markOpen();
            }
        };
        NtDropdownComponent.prototype._onMouseLeave = function (_) {
            if (this.trigger === 'hover') {
                this.overlay.markClose();
            }
        };
        NtDropdownComponent.prototype._afterOpen = function (event) {
            this.afterOpen.next(event);
        };
        NtDropdownComponent.prototype._afterClosed = function (event) {
            this.afterClosed.next(event);
        };
        NtDropdownComponent.prototype._beforeOpen = function (event) {
            this.beforeOpen.next(event);
        };
        NtDropdownComponent.prototype._beforeClosed = function (event) {
            this.beforeClosed.next(event);
        };
        NtDropdownComponent.prototype._positionChange = function (change) {
            this.positionChange.next(change);
        };
        return NtDropdownComponent;
    }());
    NtDropdownComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-dropdown, [nt-dropdown]',
                    template: "<ng-content></ng-content>\n<nt-overlay\n  overlayClass=\"nt-dropdown-overlay\"\n  [origin]=\"origin\"\n  [position]=\"position\"\n  [arrow]=\"pane?.arrow\"\n  (afterOpen)=\"_afterOpen($event)\"\n  (afterClosed)=\"_afterClosed($event)\"\n  (beforeOpen)=\"_beforeOpen($event)\"\n  (beforeClosed)=\"_beforeClosed($event)\"\n  (overlayEnter)=\"_onMouseEnter($event)\"\n  (overlayLeave)=\"_onMouseLeave($event)\"\n  (positionChange)=\"_positionChange($event)\">\n  <ng-content select=\"nt-dropdown-pane\"></ng-content>\n</nt-overlay>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    host: {
                        '(click)': '_onClick($event)',
                        '(mouseenter)': '_onMouseEnter($event)',
                        '(mouseleave)': '_onMouseLeave($event)'
                    },
                    providers: [
                        { provide: NT_DROPDOWN_PARENT_COMPONENT, useExisting: NtDropdownComponent }
                    ]
                },] }
    ];
    NtDropdownComponent.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    NtDropdownComponent.propDecorators = {
        position: [{ type: core.Input }],
        trigger: [{ type: core.Input }],
        afterOpen: [{ type: core.Output }],
        afterClosed: [{ type: core.Output }],
        beforeOpen: [{ type: core.Output }],
        beforeClosed: [{ type: core.Output }],
        positionChange: [{ type: core.Output }],
        overlay: [{ type: core.ViewChild, args: [overlay.NtOverlayComponent, { static: true },] }],
        pane: [{ type: core.ContentChild, args: [NtDropdownPaneComponent,] }]
    };

    var NtDropdownModule = /** @class */ (function () {
        function NtDropdownModule() {
        }
        return NtDropdownModule;
    }());
    NtDropdownModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        observers.ObserversModule,
                        overlay.NtOverlayModule
                    ],
                    exports: [
                        NtDropdownComponent,
                        NtDropdownPaneComponent
                    ],
                    declarations: [
                        NtDropdownComponent,
                        NtDropdownPaneComponent
                    ]
                },] }
    ];

    exports.NT_DROPDOWN_PARENT_COMPONENT = NT_DROPDOWN_PARENT_COMPONENT;
    exports.NtDropdownComponent = NtDropdownComponent;
    exports.NtDropdownModule = NtDropdownModule;
    exports.NtDropdownPaneComponent = NtDropdownPaneComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=dropdown.umd.js.map
