(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@ng-tangram/components/button'), require('@ng-tangram/components/overlay'), require('@angular/cdk/overlay')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/components/popconfirm', ['exports', '@angular/common', '@angular/core', '@ng-tangram/components/button', '@ng-tangram/components/overlay', '@angular/cdk/overlay'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.popconfirm = {}), global.ng.common, global.ng.core, global.nt.components.button, global.nt.components.overlay, global.ng.cdk.overlay));
}(this, (function (exports, common, core, button, overlay, overlay$1) { 'use strict';

    var NtPopConfirmComponent = /** @class */ (function () {
        function NtPopConfirmComponent(_elementRef) {
            this._elementRef = _elementRef;
            this._title = '';
            this.position = overlay.NtOverlayPosition.Top;
            this.confirmText = '确认';
            this.cancelText = '取消';
            this.confirm = new core.EventEmitter();
            this.cancel = new core.EventEmitter();
            this.afterOpen = new core.EventEmitter();
            this.afterClosed = new core.EventEmitter();
            this.beforeOpen = new core.EventEmitter();
            this.beforeClosed = new core.EventEmitter();
            this.positionChange = new core.EventEmitter();
            this.origin = new overlay$1.CdkOverlayOrigin(this._elementRef);
        }
        Object.defineProperty(NtPopConfirmComponent.prototype, "title", {
            get: function () { return this._title; },
            set: function (value) { this._title = value; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtPopConfirmComponent.prototype, "template", {
            get: function () { return this._template; },
            set: function (value) { this._template = value; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtPopConfirmComponent.prototype, "popconfirm", {
            set: function (value) {
                if (value instanceof core.TemplateRef) {
                    this._template = value;
                }
                else {
                    this._title = value;
                    this._template = null;
                }
            },
            enumerable: false,
            configurable: true
        });
        NtPopConfirmComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            var change = changes.title || changes.template || changes.popover;
            if (change && !change.firstChange) {
                Promise.resolve().then(function () {
                    _this.overlay.forceUpdatePosition();
                });
            }
        };
        NtPopConfirmComponent.prototype._closeOverlay = function (event, isConfirm) {
            (isConfirm ? this.confirm : this.cancel).emit();
            this.overlay.close();
            event.stopPropagation();
        };
        NtPopConfirmComponent.prototype._afterOpen = function (event) {
            this.afterOpen.next(event);
        };
        NtPopConfirmComponent.prototype._afterClosed = function (event) {
            this.afterClosed.next(event);
        };
        NtPopConfirmComponent.prototype._beforeOpen = function (event) {
            this.beforeOpen.next(event);
        };
        NtPopConfirmComponent.prototype._beforeClosed = function (event) {
            this.beforeClosed.next(event);
        };
        NtPopConfirmComponent.prototype._positionChange = function (change) {
            this.positionChange.next(change);
        };
        return NtPopConfirmComponent;
    }());
    NtPopConfirmComponent.decorators = [
        { type: core.Component, args: [{
                    selector: '[nt-popconfirm]',
                    template: "<ng-content></ng-content>\n<nt-overlay\n  overlayClass=\"nt-popconfirm-overlay\"\n  arrow\n  [origin]=\"origin\"\n  [position]=\"position\"\n  (afterOpen)=\"_afterOpen($event)\"\n  (afterClosed)=\"_afterClosed($event)\"\n  (beforeOpen)=\"_beforeOpen($event)\"\n  (beforeClosed)=\"_beforeClosed($event)\"\n  (positionChange)=\"_positionChange($event)\">\n  <div class=\"nt-popconfirm\">\n    <div class=\"nt-popconfirm-title\" *ngIf=\"template\"><ng-container *ngTemplateOutlet=\"template\"></ng-container></div>\n    <div class=\"nt-popconfirm-title\" *ngIf=\"!template\" [innerHtml]=\"title\"></div>\n    <div class=\"nt-popconfirm-action\">\n      <button nt-button color=\"secondary\" size=\"tiny\" (click)=\"_closeOverlay($event, false)\">{{cancelText}}</button>\n      <button nt-button size=\"tiny\" (click)=\"_closeOverlay($event, true)\">{{confirmText}}</button>\n    </div>\n  </div>\n</nt-overlay>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    host: {
                        '(click)': 'overlay.toggle()'
                    }
                },] }
    ];
    NtPopConfirmComponent.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    NtPopConfirmComponent.propDecorators = {
        title: [{ type: core.Input }],
        template: [{ type: core.Input }],
        popconfirm: [{ type: core.Input, args: ['nt-popconfirm',] }],
        position: [{ type: core.Input }],
        confirmText: [{ type: core.Input }],
        cancelText: [{ type: core.Input }],
        confirm: [{ type: core.Output }],
        cancel: [{ type: core.Output }],
        afterOpen: [{ type: core.Output }],
        afterClosed: [{ type: core.Output }],
        beforeOpen: [{ type: core.Output }],
        beforeClosed: [{ type: core.Output }],
        positionChange: [{ type: core.Output }],
        overlay: [{ type: core.ViewChild, args: [overlay.NtOverlayComponent, { static: true },] }]
    };

    var NtPopConfirmModule = /** @class */ (function () {
        function NtPopConfirmModule() {
        }
        return NtPopConfirmModule;
    }());
    NtPopConfirmModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, overlay.NtOverlayModule, button.NtButtonModule],
                    exports: [NtPopConfirmComponent],
                    declarations: [NtPopConfirmComponent]
                },] }
    ];

    exports.NtPopConfirmComponent = NtPopConfirmComponent;
    exports.NtPopConfirmModule = NtPopConfirmModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=popconfirm.umd.js.map
