(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/animations'), require('@angular/cdk/coercion'), require('@ng-tangram/components/core')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/components/scrim', ['exports', '@angular/common', '@angular/core', '@angular/animations', '@angular/cdk/coercion', '@ng-tangram/components/core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.scrim = {}), global.ng.common, global.ng.core, global.ng.animations, global.ng.cdk.coercion, global.nt.components.core));
}(this, (function (exports, common, core, animations, coercion, core$1) { 'use strict';

    var NtScrimComponent = /** @class */ (function () {
        function NtScrimComponent() {
            this._isOpen = false;
            this.text = '';
        }
        Object.defineProperty(NtScrimComponent.prototype, "isOpen", {
            get: function () { return this._isOpen; },
            set: function (value) { this._isOpen = coercion.coerceBooleanProperty(value); },
            enumerable: false,
            configurable: true
        });
        return NtScrimComponent;
    }());
    NtScrimComponent.decorators = [
        { type: core.Component, args: [{
                    selector: '[nt-scrim], nt-scrim',
                    template: "<div class=\"nt-scrim\" *ngIf=\"isOpen\" [@fade]>\n  <div class=\"nt-scrim-animation\">\n    <div class=\"nt-scrim-loading\"></div>\n  </div>\n  <h3 class=\"nt-scrim-text\">{{ text }}</h3>\n</div>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    animations: [
                        animations.trigger('fade', [
                            animations.transition('void => *', core$1.fadeIn(.15)),
                            animations.transition('* => void', core$1.fadeOut(.15))
                        ])
                    ]
                },] }
    ];
    NtScrimComponent.ctorParameters = function () { return []; };
    NtScrimComponent.propDecorators = {
        text: [{ type: core.Input }]
    };

    var NtScrimDirective = /** @class */ (function () {
        function NtScrimDirective(platformId, _elementRef, _renderer, _componentFactoryResolver, _viewContainerRef) {
            this.platformId = platformId;
            this._elementRef = _elementRef;
            this._renderer = _renderer;
            this._componentFactoryResolver = _componentFactoryResolver;
            this._viewContainerRef = _viewContainerRef;
            var componentFactory = this._componentFactoryResolver.resolveComponentFactory(NtScrimComponent);
            this._componentRef = this._viewContainerRef.createComponent(componentFactory);
            if (common.isPlatformBrowser(this.platformId)) {
                var style = window.getComputedStyle(this._elementRef.nativeElement);
                if (style.position !== 'absolute' || style.position !== 'absolute') {
                    this._renderer.setStyle(this._elementRef.nativeElement, 'position', 'relative');
                }
                this._renderer.appendChild(this._elementRef.nativeElement, this._componentRef.location.nativeElement);
            }
        }
        Object.defineProperty(NtScrimDirective.prototype, "text", {
            set: function (value) { this._componentRef.instance.text = value; },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtScrimDirective.prototype, "scrim", {
            set: function (value) { this._componentRef.instance.isOpen = coercion.coerceBooleanProperty(value); },
            enumerable: false,
            configurable: true
        });
        NtScrimDirective.prototype.ngOnDestroy = function () {
            if (common.isPlatformBrowser(this.platformId)) {
                this._renderer.removeChild(this._elementRef.nativeElement, this._componentRef.location.nativeElement);
                this._componentRef.destroy();
            }
        };
        return NtScrimDirective;
    }());
    NtScrimDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[ntScrim]'
                },] }
    ];
    NtScrimDirective.ctorParameters = function () { return [
        { type: Object, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] }] },
        { type: core.ElementRef },
        { type: core.Renderer2 },
        { type: core.ComponentFactoryResolver },
        { type: core.ViewContainerRef }
    ]; };
    NtScrimDirective.propDecorators = {
        text: [{ type: core.Input, args: ['scrimText',] }],
        scrim: [{ type: core.Input, args: ['ntScrim',] }]
    };

    var NtScrimModule = /** @class */ (function () {
        function NtScrimModule() {
        }
        return NtScrimModule;
    }());
    NtScrimModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [NtScrimComponent, NtScrimDirective],
                    declarations: [NtScrimComponent, NtScrimDirective],
                    entryComponents: [NtScrimComponent]
                },] }
    ];

    exports.NtScrimComponent = NtScrimComponent;
    exports.NtScrimDirective = NtScrimDirective;
    exports.NtScrimModule = NtScrimModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=scrim.umd.js.map
