export declare const FILE_EXTENSIONS_MAP: {
    rar: string;
    zip: string;
    cab: string;
    iso: string;
    jar: string;
    '7z': string;
    tar: string;
    gz: string;
    bz2: string;
    z: string;
    jpg: string;
    bmp: string;
    eps: string;
    gif: string;
    mif: string;
    miff: string;
    png: string;
    tif: string;
    tiff: string;
    svg: string;
    wmf: string;
    jpe: string;
    jpeg: string;
    dib: string;
    ico: string;
    tga: string;
    cut: string;
    pic: string;
    wma: string;
    ra: string;
    ogg: string;
    mpc: string;
    m4a: string;
    aac: string;
    mpa: string;
    mp2: string;
    m1a: string;
    m2a: string;
    mp3: string;
    mid: string;
    midi: string;
    rmi: string;
    mka: string;
    ac3: string;
    dts: string;
    cda: string;
    au: string;
    snd: string;
    aif: string;
    aifc: string;
    aiff: string;
    mp4: string;
    avi: string;
    wav: string;
    wmv: string;
    rmvb: string;
    rm: string;
    flv: string;
    mkv: string;
    mpg: string;
    mpeg: string;
    mov: string;
    '3gp': string;
    doc: string;
    docx: string;
    xls: string;
    xlsx: string;
    ppt: string;
    pptx: string;
};
export declare const FILE_MIME_TYPES_MAP: {
    'application/x-bzip': string;
    'application/x-bzip2': string;
    'application/msword': string;
    'application/vnd.openxmlformats-officedocument.wordprocessingml.document': string;
    'application/vnd.ms-fontobject': string;
    'application/epub+zip': string;
    'application/gzip': string;
    'application/java-archive': string;
    'application/json': string;
    'application/pdf': string;
    'application/php': string;
    'application/vnd.ms-powerpoint': string;
    'application/vnd.openxmlformats-officedocument.presentationml.presentation': string;
    'application/x-rar-compressed': string;
    'application/x-sh': string;
    'application/x-tar': string;
    'application/xhtml+xml': string;
    'application/vnd.ms-excel': string;
    'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet': string;
    'application/xml': string;
    'application/vnd.mozilla.xul+xml': string;
    'application/zip': string;
    'application/x-7z-compressed': string;
    'text/css': string;
    'text/csv': string;
    'text/html': string;
    'text/calendar': string;
    'text/javascript': string;
    'text/xml': string;
    'font/otf': string;
    'font/ttf': string;
    'font/woff': string;
    'font/woff2': string;
    'image/bmp': string;
    'image/gif': string;
    'image/vnd.microsoft.icon': string;
    'image/jpeg': string;
    'image/png': string;
    'image/svg+xml': string;
    'image/tiff': string;
    'image/webp': string;
    'video/x-msvideo': string;
    'video/mpeg': string;
    'video/ogg': string;
    'video/mp2t': string;
    'video/webm': string;
    'video/3gpp': string;
    'video/3gpp2': string;
    'audio/aac': string;
    'audio/midi\u00A0audio/x-midi': string;
    'audio/mpeg': string;
    'audio/ogg': string;
    'audio/opus': string;
    'audio/wav': string;
    'audio/webm': string;
    'audio/3gpp': string;
    'audio/3gpp2': string;
};
export declare const NT_FILE_CATEGORIES: {
    [key: string]: string;
};
export declare function findCategoryByFile(file: File): string;
export declare function findCategoryByExtensions(extension: string): any;
export declare function findCategoryByMimeType(type: string): any;
