import { ChangeDetectorRef, EventEmitter } from '@angular/core';
import { DateAdapter } from '@ng-tangram/components/core';
import { NtDatePickerCell } from './datepicker-models';
export declare const yearsPerPage = 12;
export declare const yearsPerRow = 3;
export declare class NtDatePickerMultiYearComponent<D> {
    private _changeDetectorRef;
    _dateAdapter: DateAdapter<D>;
    _years: NtDatePickerCell[][];
    _todayYear: number;
    _selectedYear: number | null;
    private _activeDate;
    private _selected;
    private _minDate;
    private _maxDate;
    get activeDate(): D;
    set activeDate(value: D);
    get selected(): D | null;
    set selected(value: D | null);
    get minDate(): D | null;
    set minDate(value: D | null);
    get maxDate(): D | null;
    set maxDate(value: D | null);
    dateFilter: (date: D) => boolean;
    readonly selectedChange: EventEmitter<D>;
    readonly yearSelected: EventEmitter<D>;
    constructor(_changeDetectorRef: ChangeDetectorRef, _dateAdapter: DateAdapter<D>);
    ngAfterContentInit(): void;
    _init(): void;
    _yearSelected(year: number): void;
    private _createCellForYear;
    private _shouldEnableYear;
    private _getValidDateOrNull;
}
