import { ConnectionPositionPair, HorizontalConnectionPos, VerticalConnectionPos } from '@angular/cdk/overlay';
export declare enum NtOverlayPosition {
    Bottom = "bottom",
    BottomLeft = "bottomLeft",
    BottomRight = "bottomRight",
    Top = "top",
    TopLeft = "topLeft",
    TopRight = "topRight",
    Left = "left",
    LeftTop = "leftTop",
    LeftBottom = "leftBottom",
    Right = "right",
    RightTop = "rightTop",
    RightBottom = "rightBottom"
}
export declare enum NtOverlayOrientation {
    Vertical = "vertical",
    Horizontal = "horizontal"
}
export declare const BOTTOM_LEFT: ConnectionPositionPair, BOTTOM_CENTER: ConnectionPositionPair, BOTTOM_RIGHT: ConnectionPositionPair, TOP_LEFT: ConnectionPositionPair, TOP_CENTER: ConnectionPositionPair, TOP_RIGHT: ConnectionPositionPair, LEFT_TOP: ConnectionPositionPair, LEFT_CENTER: ConnectionPositionPair, LEFT_BOTTOM: ConnectionPositionPair, RIGHT_TOP: ConnectionPositionPair, RIGHT_CENTER: ConnectionPositionPair, RIGHT_BOTTOM: ConnectionPositionPair;
export declare const NT_OVERLAY_POSITION_PAIRS: {
    bottom: ConnectionPositionPair[];
    bottomLeft: ConnectionPositionPair[];
    bottomRight: ConnectionPositionPair[];
    top: ConnectionPositionPair[];
    topLeft: ConnectionPositionPair[];
    topRight: ConnectionPositionPair[];
    left: ConnectionPositionPair[];
    leftTop: ConnectionPositionPair[];
    leftBottom: ConnectionPositionPair[];
    right: ConnectionPositionPair[];
    rightTop: ConnectionPositionPair[];
    rightBottom: ConnectionPositionPair[];
};
export declare function getConnectionPositionPair(originX: HorizontalConnectionPos, originY: VerticalConnectionPos, overlayX: HorizontalConnectionPos, overlayY: VerticalConnectionPos): ConnectionPositionPair;
export declare function getPositionClassName(pair: ConnectionPositionPair): string;
export declare function getPositionOrientation(position: string): NtOverlayOrientation;
