import { EventEmitter } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
export declare class NtRadioChange<T> {
    source: NtRadioComponent<T>;
    selected: boolean;
    constructor(source: NtRadioComponent<T>, selected: boolean);
}
export declare class NtRadioComponent<T> implements ControlValueAccessor {
    ngControl: NgControl;
    readonly id: string;
    private _value;
    private _disabled;
    private _readonly;
    private _checked;
    private _name;
    tabIndex: number;
    set value(value: T | null);
    get value(): T | null;
    set disabled(value: boolean);
    get disabled(): boolean;
    set readonly(value: boolean);
    get readonly(): boolean;
    get checked(): boolean;
    set checked(value: boolean);
    set name(value: string);
    get name(): string;
    readonly change: EventEmitter<NtRadioChange<T>>;
    private _onChange;
    private _onTouched;
    constructor(tabIndex: string, ngControl: NgControl);
    writeValue(value: T): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    setDisabledState(isDisabled: boolean): void;
    _onInputClick(event: Event): void;
    _onInputChange(event: Event): void;
    private _emitChangeEvent;
}
